package dev.shadowsoffire.apotheosis.adventure.loot;

import java.util.function.Supplier;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import net.minecraftforge.common.loot.IGlobalLootModifier;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import net.minecraft.world.level.storage.loot.parameters.LootContextParams;
import dev.shadowsoffire.apotheosis.Apotheosis;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.item.ItemStack;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import net.minecraft.world.level.storage.loot.predicates.LootItemCondition;
import com.mojang.serialization.Codec;
import net.minecraftforge.common.loot.LootModifier;

public class AffixHookLootModifier extends LootModifier
{
    public static final Codec<AffixHookLootModifier> CODEC;
    
    protected AffixHookLootModifier() {
        super(new LootItemCondition[0]);
    }
    
    protected ObjectArrayList<ItemStack> doApply(final ObjectArrayList<ItemStack> generatedLoot, final LootContext ctx) {
        if (!Apotheosis.enableAdventure) {
            return generatedLoot;
        }
        if (ctx.m_78936_(LootContextParams.f_81463_)) {
            final ItemStack tool = (ItemStack)ctx.m_165124_(LootContextParams.f_81463_);
            SocketHelper.getGems(tool).modifyLoot((ObjectArrayList)generatedLoot, ctx);
            AffixHelper.streamAffixes(tool).forEach(inst -> inst.modifyLoot(generatedLoot, ctx));
        }
        return generatedLoot;
    }
    
    public Codec<? extends IGlobalLootModifier> codec() {
        return (Codec<? extends IGlobalLootModifier>)AffixHookLootModifier.CODEC;
    }
    
    static {
        CODEC = Codec.unit((Supplier)AffixHookLootModifier::new);
    }
}
